//
//  PhotoStore.swift
//  Photorama
//
//  Created by Paul Pollock on 8/22/17.
//  Copyright © 2017 Paul Pollock. All rights reserved.
//

import UIKit

enum PhotosResult   {
    case success([Photo])
    case failure(Error)
}

class PhotoStore    {
    private let session: URLSession = {
        let config = URLSessionConfiguration.default
        return URLSession(configuration: config)
    }()
//}

    func fetchInterestingPhotos(completion: @escaping (PhotosResult) -> Void) {
//        print("func fetchInterestingPhotos")
        let url = FlickrAPI.interestingPhotosURL
        let request = URLRequest(url: url)
        let task = session.dataTask(with: request) {
            (data, response, error) -> Void in
            
            let result = self.processPhotosRequest(data: data, error: error)
//            print("(PhotoStore.swift) error: \(String(describing: error))")
//            print("(PhotoStore.swift) data: \(String(describing: data))")
//            print("(PhotoStore.swift) result: \(result)")  //  result: failure(Photorama.FlickrError.invalidJSONData)
            completion(result)
        }
        task.resume()
    }
    
    private func processPhotosRequest(data: Data?, error: Error?)   ->  PhotosResult    {
        guard let jsonData = data else  {
            print("return .failure(error!)")    //  Does not appear
            return .failure(error!)
        }
//        print("func processPhotosRequest(data: Data?")  //  Appears
//        print("data: \(String(describing: data))")      //  Optional(35356 bytes)
//        print("error: \(String(describing: error))")    //  nil
        return FlickrAPI.photos(fromJSON: jsonData)
    }
}
